; ====================================================;
;                                                     ;
;       hid.inc for EC v2 Fasm visual projects        ;
;                   (version 1.0.0)                   ;
;                                                     ;
;            Copyright  Ramon Sala - 2022            ;
;                                                     ;
; ====================================================;

if ~defined HID_INC
define HID_INC 1

DATA_SIZE_MASK                                  equ     003H
TYPE_MASK                                       equ     00CH
TAG_MASK                                        equ     0F0H

DATA_SIZE_0                                     equ     000H
DATA_SIZE_1                                     equ     001H
DATA_SIZE_2                                     equ     002H
DATA_SIZE_4                                     equ     003H

TYPE_MAIN                                       equ     000H
TYPE_GLOBAL                                     equ     004H
TYPE_LOCAL                                      equ     008H

TAG_MAIN_INPUT                                  equ     080H
TAG_MAIN_OUTPUT                                 equ     090H
TAG_MAIN_COLLECTION                             equ     0A0H
TAG_MAIN_FEATURE                                equ     0B0H
TAG_MAIN_ENDCOLLECTION                          equ     0C0H

TAG_GLOBAL_USAGEPAGE                            equ     000H
TAG_GLOBAL_LOGICALMIN                           equ     010H
TAG_GLOBAL_LOGICALMAX                           equ     020H
TAG_GLOBAL_PHYSMIN                              equ     030H
TAG_GLOBAL_PHYSMAX                              equ     040H
TAG_GLOBAL_UNITEXP                              equ     050H
TAG_GLOBAL_UNIT                                 equ     060H
TAG_GLOBAL_REPORTSIZE                           equ     070H
TAG_GLOBAL_REPORTID                             equ     080H
TAG_GLOBAL_REPORTCOUNT                          equ     090H
TAG_GLOBAL_PUSH                                 equ     0A0H
TAG_GLOBAL_POP                                  equ     0B0H

TAG_LOCAL_USAGE                                 equ     000H
TAG_LOCAL_USAGEMIN                              equ     010H
TAG_LOCAL_USAGEMAX                              equ     020H

HID_GET_REPORT                                  equ     001H
HID_GET_IDLE                                    equ     002H
HID_GET_PROTOCOL                                equ     003H
HID_SET_REPORT                                  equ     009H
HID_SET_IDLE                                    equ     00AH
HID_SET_PROTOCOL                                equ     00BH

HID_HID_DESCRIPTOR_TYPE                         equ     021H
HID_REPORT_DESCRIPTOR_TYPE                      equ     022H
HID_PHYSICAL_DESCRIPTOR_TYPE                    equ     023H

HID_SUBCLASS_NONE                               equ     0
HID_SUBCLASS_BOOT_INTERFACE                     equ     1

HID_PROTOCOL_NONE                               equ     000H
HID_PROTOCOL_KEYBOARD                           equ     001H
HID_PROTOCOL_MOUSE                              equ     002H

HID_BOOT_PROTOCOL                               equ     000H
HID_RPT_PROTOCOL                                equ     001H

HID_REPORT_TYPE_INPUT                           equ     1
HID_REPORT_TYPE_OUTPUT                          equ     2
HID_REPORT_TYPE_FEATURE                         equ     3

HID_REQUEST_GET_REPORT                          equ     001H
HID_REQUEST_GET_IDLE                            equ     002H
HID_REQUEST_GET_PROTOCOL                        equ     003H
HID_REQUEST_SET_REPORT                          equ     009H
HID_REQUEST_SET_IDLE                            equ     00AH
HID_REQUEST_SET_PROTOCOL                        equ     00BH

HID_DESCRIPTOR_HID                              equ     021H
HID_DESCRIPTOR_REPORT                           equ     022H
HID_DESRIPTOR_PHY                               equ     023H

HID_INTF                                        equ     003H

HID_BOOT_INTF_SUBCLASS                          equ     001H


HID_ITEM_TYPE_MAIN                              equ     0
HID_ITEM_TYPE_GLOBAL                            equ     1
HID_ITEM_TYPE_LOCAL                             equ     2
HID_ITEM_TYPE_RESERVED                          equ     3

HID_LONG_ITEM_PREFIX                            equ     0FEH

bmHID_MAIN_ITEM_TAG                             equ     0FCH

bmHID_MAIN_ITEM_INPUT                           equ     080H
bmHID_MAIN_ITEM_OUTPUT                          equ     090H
bmHID_MAIN_ITEM_COLLECTION                      equ     0A0H
bmHID_MAIN_ITEM_FEATURE                         equ     0B0H
bmHID_MAIN_ITEM_END_COLLECTION                  equ     0CEH

HID_MAIN_ITEM_COLLECTION_PHYSICAL               equ     0
HID_MAIN_ITEM_COLLECTION_APPLICATION            equ     1
HID_MAIN_ITEM_COLLECTION_LOGICAL                equ     2
HID_MAIN_ITEM_COLLECTION_REPORT                 equ     3
HID_MAIN_ITEM_COLLECTION_NAMED_ARRAY            equ     4
HID_MAIN_ITEM_COLLECTION_USAGE_SWITCH           equ     5
HID_MAIN_ITEM_COLLECTION_USAGE_MODIFIER         equ     6


;========================================  Functions ======================================;
if defined APP_WIN64
    extrn '__imp_HidD_FlushQueue' as HidD_FlushQueue:qword
    extrn '__imp_HidD_FreePreparsedData' as HidD_FreePreparsedData:qword
    extrn '__imp_HidD_GetAttributes' as HidD_GetAttributes:qword
    extrn '__imp_HidD_GetConfiguration' as HidD_GetConfiguration:qword
    extrn '__imp_HidD_GetFeature' as HidD_GetFeature:qword
    extrn '__imp_HidD_GetHidGuid' as HidD_GetHidGuid:qword
    extrn '__imp_HidD_GetIndexedString' as HidD_GetIndexedString:qword
    extrn '__imp_HidD_GetInputReport' as HidD_GetInputReport:qword
    extrn '__imp_HidD_GetManufacturerString' as HidD_GetManufacturerString:qword
    extrn '__imp_HidD_GetMsGenreDescriptor' as HidD_GetMsGenreDescriptor:qword
    extrn '__imp_HidD_GetNumInputBuffers' as HidD_GetNumInputBuffers:qword
    extrn '__imp_HidD_GetPhysicalDescriptor' as HidD_GetPhysicalDescriptor:qword
    extrn '__imp_HidD_GetPreparsedData' as HidD_GetPreparsedData:qword
    extrn '__imp_HidD_GetProductString' as HidD_GetProductString:qword
    extrn '__imp_HidD_GetSerialNumberString' as HidD_GetSerialNumberString:qword
    extrn '__imp_HidD_Hello' as HidD_Hello:qword
    extrn '__imp_HidD_SetConfiguration' as HidD_SetConfiguration:qword
    extrn '__imp_HidD_SetFeature' as HidD_SetFeature:qword
    extrn '__imp_HidD_SetNumInputBuffers' as HidD_SetNumInputBuffers:qword
    extrn '__imp_HidD_SetOutputReport' as HidD_SetOutputReport:qword
    extrn '__imp_HidP_GetButtonArray' as HidP_GetButtonArray:qword
    extrn '__imp_HidP_GetButtonCaps' as HidP_GetButtonCaps:qword
    extrn '__imp_HidP_GetCaps' as HidP_GetCaps:qword
    extrn '__imp_HidP_GetData' as HidP_GetData:qword
    extrn '__imp_HidP_GetExtendedAttributes' as HidP_GetExtendedAttributes:qword
    extrn '__imp_HidP_GetLinkCollectionNodes' as HidP_GetLinkCollectionNodes:qword
    extrn '__imp_HidP_GetScaledUsageValue' as HidP_GetScaledUsageValue:qword
    extrn '__imp_HidP_GetSpecificButtonCaps' as HidP_GetSpecificButtonCaps:qword
    extrn '__imp_HidP_GetSpecificValueCaps' as HidP_GetSpecificValueCaps:qword
    extrn '__imp_HidP_GetUsageValue' as HidP_GetUsageValue:qword
    extrn '__imp_HidP_GetUsageValueArray' as HidP_GetUsageValueArray:qword
    extrn '__imp_HidP_GetUsages' as HidP_GetUsages:qword
    extrn '__imp_HidP_GetUsagesEx' as HidP_GetUsagesEx:qword
    extrn '__imp_HidP_GetValueCaps' as HidP_GetValueCaps:qword
    extrn '__imp_HidP_InitializeReportForID' as HidP_InitializeReportForID:qword
    extrn '__imp_HidP_MaxDataListLength' as HidP_MaxDataListLength:qword
    extrn '__imp_HidP_MaxUsageListLength' as HidP_MaxUsageListLength:qword
    extrn '__imp_HidP_SetButtonArray' as HidP_SetButtonArray:qword
    extrn '__imp_HidP_SetData' as HidP_SetData:qword
    extrn '__imp_HidP_SetScaledUsageValue' as HidP_SetScaledUsageValue:qword
    extrn '__imp_HidP_SetUsageValue' as HidP_SetUsageValue:qword
    extrn '__imp_HidP_SetUsageValueArray' as HidP_SetUsageValueArray:qword
    extrn '__imp_HidP_SetUsages' as HidP_SetUsages:qword
    extrn '__imp_HidP_TranslateUsagesToI8042ScanCodes' as HidP_TranslateUsagesToI8042ScanCodes:qword
    extrn '__imp_HidP_UnsetUsages' as HidP_UnsetUsages:qword
    extrn '__imp_HidP_UsageListDifference' as HidP_UsageListDifference:qword
else
    extrn '__imp__HidD_FlushQueue@4' as HidD_FlushQueue:dword
    extrn '__imp__HidD_FreePreparsedData@4' as HidD_FreePreparsedData:dword
    extrn '__imp__HidD_GetAttributes@8' as HidD_GetAttributes:dword
    extrn '__imp__HidD_GetConfiguration@12' as HidD_GetConfiguration:dword
    extrn '__imp__HidD_GetFeature@12' as HidD_GetFeature:dword
    extrn '__imp__HidD_GetHidGuid@4' as HidD_GetHidGuid:dword
    extrn '__imp__HidD_GetIndexedString@16' as HidD_GetIndexedString:dword
    extrn '__imp__HidD_GetInputReport@12' as HidD_GetInputReport:dword
    extrn '__imp__HidD_GetManufacturerString@12' as HidD_GetManufacturerString:dword
    extrn '__imp__HidD_GetMsGenreDescriptor@12' as HidD_GetMsGenreDescriptor:dword
    extrn '__imp__HidD_GetNumInputBuffers@8' as HidD_GetNumInputBuffers:dword
    extrn '__imp__HidD_GetPhysicalDescriptor@12' as HidD_GetPhysicalDescriptor:dword
    extrn '__imp__HidD_GetPreparsedData@8' as HidD_GetPreparsedData:dword
    extrn '__imp__HidD_GetProductString@12' as HidD_GetProductString:dword
    extrn '__imp__HidD_GetSerialNumberString@12' as HidD_GetSerialNumberString:dword
    extrn '__imp__HidD_Hello@8' as HidD_Hello:dword
    extrn '__imp__HidD_SetConfiguration@12' as HidD_SetConfiguration:dword
    extrn '__imp__HidD_SetFeature@12' as HidD_SetFeature:dword
    extrn '__imp__HidD_SetNumInputBuffers@8' as HidD_SetNumInputBuffers:dword
    extrn '__imp__HidD_SetOutputReport@12' as HidD_SetOutputReport:dword
    extrn '__imp__HidP_GetButtonArray@36' as HidP_GetButtonArray:dword
    extrn '__imp__HidP_GetButtonCaps@16' as HidP_GetButtonCaps:dword
    extrn '__imp__HidP_GetCaps@8' as HidP_GetCaps:dword
    extrn '__imp__HidP_GetData@24' as HidP_GetData:dword
    extrn '__imp__HidP_GetExtendedAttributes@20' as HidP_GetExtendedAttributes:dword
    extrn '__imp__HidP_GetLinkCollectionNodes@12' as HidP_GetLinkCollectionNodes:dword
    extrn '__imp__HidP_GetScaledUsageValue@32' as HidP_GetScaledUsageValue:dword
    extrn '__imp__HidP_GetSpecificButtonCaps@28' as HidP_GetSpecificButtonCaps:dword
    extrn '__imp__HidP_GetSpecificValueCaps@28' as HidP_GetSpecificValueCaps:dword
    extrn '__imp__HidP_GetUsageValue@32' as HidP_GetUsageValue:dword
    extrn '__imp__HidP_GetUsageValueArray@36' as HidP_GetUsageValueArray:dword
    extrn '__imp__HidP_GetUsages@32' as HidP_GetUsages:dword
    extrn '__imp__HidP_GetUsagesEx@28' as HidP_GetUsagesEx:dword
    extrn '__imp__HidP_GetValueCaps@16' as HidP_GetValueCaps:dword
    extrn '__imp__HidP_InitializeReportForID@20' as HidP_InitializeReportForID:dword
    extrn '__imp__HidP_MaxDataListLength@8' as HidP_MaxDataListLength:dword
    extrn '__imp__HidP_MaxUsageListLength@12' as HidP_MaxUsageListLength:dword
    extrn '__imp__HidP_SetButtonArray@36' as HidP_SetButtonArray:dword
    extrn '__imp__HidP_SetData@24' as HidP_SetData:dword
    extrn '__imp__HidP_SetScaledUsageValue@32' as HidP_SetScaledUsageValue:dword
    extrn '__imp__HidP_SetUsageValue@32' as HidP_SetUsageValue:dword
    extrn '__imp__HidP_SetUsageValueArray@36' as HidP_SetUsageValueArray:dword
    extrn '__imp__HidP_SetUsages@32' as HidP_SetUsages:dword
    extrn '__imp__HidP_TranslateUsagesToI8042ScanCodes@24' as HidP_TranslateUsagesToI8042ScanCodes:dword
    extrn '__imp__HidP_UnsetUsages@32' as HidP_UnsetUsages:dword
    extrn '__imp__HidP_UsageListDifference@20' as HidP_UsageListDifference:dword
end if


;======================= Undocumented functions (unknown arguments) =======================;
;if defined APP_WIN64
;    extrn '__imp_HidP_GetVersionInternal' as HidP_GetVersionInternal:qword
;else
;    extrn '__imp__HidP_GetVersionInternal@??' as HidP_GetVersionInternal:dword
;end if

end if ;HID_INC
